import gensim
from gensim.models import KeyedVectors

def load_word2vec():
    """ Load Word2Vec Vectors
        Return:
            wv_from_bin: All 3 million embeddings, each lengh 300
    """
    import gensim.downloader as api
    wv_from_bin = api.load("word2vec-google-news-300")
    vocab = list(wv_from_bin.vocab.keys())
    print("Loaded vocab size %i" % len(vocab))
    return wv_from_bin

def analogy(x1, x2, y1):
    result = model.most_similar(positive=[y1, x2], negative=[x1])
    return result[0][0]



# Load word2vec embeddings
model = load_word2vec()


# Semantic Similarity / Semantic relatedness
model.most_similar('lawyer')
model.most_similar('obama')

model.most_similar('hungry')
model.most_similar(positive=['hungry'], negative=['food'])


# Analogies
model.most_similar(positive=['king', 'woman'], negative=['man'])
## OR
analogy('man','king','woman')
analogy('good', 'fantastic', 'bad')


# Semantic relatedness
print(model.doesnt_match("breakfast cereal dinner lunch".split()))
print(model.doesnt_match("degree celcius kelvin diploma".split()))

